\subsection*{ShiftRows}
\label{subsec:shiftrows}

This transformation operates on the individual rows of the state and is depicted
in Figure \ref{fig:shiftrows}. It is defined by the following expression:
\[
  s'_{r,c} = s_{r, (r + c)~\text{mod}~4} \quad \text{for} \quad 0 < r < 4 \quad
  \text{and} \quad 0 \le c < 4.
\]
We can see that each row $i$ of the state is cyclically rotated to the left by
$i$ bytes, where $0 \le i < 4$, so that the first row remains the same and the
fourth row is rotated by three bytes.

\begin{figure}[h]
  \centering \includegraphics[width=.8\textwidth]{shiftrows}
  \cprotect\caption{The \verb=ShiftRows= operation \cite{fips}.}
  \label{fig:shiftrows}
\end{figure}

Let us now show that the \verb=ShiftRows= operation is in fact a linear
transformation. A~cyclic rotation by one position of a vector of length four can
be represented by the matrix
\begin{equation}
  \label{eq:R_4}
  R_4=
  \begin{pmatrix}
    0 & 1 & 0 & 0 \\
    0 & 0 & 1 & 0 \\
    0 & 0 & 0 & 1 \\
    1 & 0 & 0 & 0
  \end{pmatrix}.
\end{equation}
Rotations by more positions can be obtained by taking higher powers of $R_4$. If
we let $r_i$ represent the $i$th row of the state, we can define the
\verb=ShiftRows= operation by the following expression
\begin{equation}
  \label{eq:shiftrows}
  \begin{pmatrix}
    r_0' \\
    r_1' \\
    r_2' \\
    r_3'
  \end{pmatrix}
  =
  \begin{pmatrix}
    I & 0  & 0   & 0 \\
    0 & R_4 & 0   & 0 \\
    0 & 0  & R^2_4 & 0 \\
    0 & 0  & 0   & R^3_4
  \end{pmatrix}
  \begin{pmatrix}
    r_0 \\
    r_1 \\
    r_2 \\
    r_3
  \end{pmatrix}.
\end{equation}
